.686			
.mmx			
;k3d			
;.xmm			
.XMM
.model	 flat, stdcall	 
option	 casemap:none, language:stdcall, dotname
assume fs:nothing


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\msvcrt.inc
include \masm32\macros\macros.asm
include \masm32\macros\timers.asm
include CpuId.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\msvcrt.lib


Main        proto

InstrJJb		 proto	 :DWORD, :DWORD,:DWORD,:DWORD
InstrJJw		 proto	 :DWORD, :DWORD,:DWORD,:DWORD
SrchBytes        proto	 :DWORD,:DWORD


.data

align 16

  LOOP_COUNT    EQU	500000
  MINUS_1       EQU 0ffffffffH

  UseLodsb=	1	; strangely enough, 1 is faster on Celeron M

align 16
  SzJJb			   db "InString - JJb:                         ",0
  SzJJw			   db "InString - JJw:                         ",0
  SzInLingo	   db "SrchBytes -  Lingo:                     ",0

szFileName db "\masm32\include\windows.inc",0
lenPattern1  dd  10 ;13
lenPattern  dd  13
lpPattrn   db  "Duplicate inc",0
lpPattrn1   db  "warning or",0
;lpPattrn   db  "n",0


  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for short searches
   align 16
    SzTest1        db "Short test with match string at end: Here it is123456712345!",13,10,0
   align 16
    SzMatch1       db "Here it is123456712345",0  
    SzResult1      db 13,10,"Search Test 1 - value expected 37; lenSrchPattern ->22",13,10,0

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  align 16
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
   align 16
  SzMatch2                               db "MMMMMMhardMMMMMMM",0  
  SzResult2      db 13,10,"Search Test 2 - value expected 1007; lenSrchPattern ->17",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background
 align 16
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
   align 16
  SzMatch3       db "Should be easier",0  
  SzResult3      db 13,10,"Search Test 3 - value expected 1008 ;lenSrchPattern ->16",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch seems to have advantage for longer match lengths 
  align 16
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
   align 16
  SzMatch4       db "Many repetitions",0  
  SzResult4      db 13,10,"Search Test 4 - value expected 1008 ;lenSrchPattern ->16",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch can't seem to take advantage of the earlier match failure 
  align 16
  SzTest5        db 72 dup ("Many repeatsns"), "Many repetitions", 0
   align 16
  SzMatch5       db "Many repetitions",0  
  SzResult5      db 13,10,"Search Test 5 - value expected 1008 ;lenSrchPattern ->16",13,10,0

  ; matchlen 16, sourcelen 1024
  ; serious disadvantage for Boyer-Moore for this close repeating pattern
  ; as all the repeats must check from the matching end almost to the start
  align 16
  SzTest6        db 72 dup ("No repetitions"), "Many repetitions", 0
   align 16
  SzMatch6       db "Many repetitions",0  
  SzResult6      db 13,10,"Search Test 6 - value expected 1008 ;lenSrchPattern ->16",13,10,0

  ; matchlen 14, sourcelen 1024
  ; more random text, BInStrWithLen catching up with Boyer-Moore
  align 16
  SzTest7   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
   align 16
SzMatch7       db "no repetitions",0  
SzResult7      db 13,10,"Search Test 7 - value expected 1009 ;lenSrchPattern ->14",13,10,0
				dd 0

  ; search pattern =1 byte
 align 16
  SzTest8   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, x few or no repetitions", 0
   align 16
SzMatch8       db  0EFh, 0  
SzResult8      db 13,10,"Search Test 8 - value expected 1001 ;lenSrchPattern ->1",13,10,0
				dd 0
  ; search pattern =2 bytes
  align 16
  SzTest9   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text,1 few or no repetitions", 0
   align 16
SzMatch9       db  0EFh,31h, 0  
SzResult9      db 13,10,"Search Test 9 - value expected 1001 ;lenSrchPattern ->2",13,10,0
				dd 0

  ; search pattern =3 bytes
  align 16
  SzTest10   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text,12 few or no repetitions", 0
   align 16
SzMatch10       db  0EFh,31h,32h, 0  
SzResult10      db 13,10,"Search Test 10 - value expected 1001 ;lenSrchPattern ->3",13,10,0
				dd 0

  ; search pattern =4 bytes
  align 16
  SzTest11   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text,123 few or no repetitions", 0
   align 16
SzMatch11       db  0EFh,31h,32h,33h, 0  
SzResult11      db 13,10,"Search Test 11 - value expected 1001 ;lenSrchPattern ->4",13,10,0
				dd 0

  ; search pattern =5 bytes
  align 16
  SzTest12   db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text,1234 few or no repetitions", 0
   align 16
SzMatch12       db  0EFh,31h,32h,33h,34h, 0  
SzResult12      db 13,10,"Search Test 12 - value expected 1001 ;lenSrchPattern ->5",13,10,0
				dd 0
SzResult13      db 13,10,"Search Test 13 --Find 'Duplicate inc' in 'windows.inc' ;lenSrchPattern ->13",13,10,0
				dd 0
SzResult14      db 13,10,"Search Test 14 --Find 'warning or' in 'windows.inc' ;lenSrchPattern ->10",13,10,0
				dd 0

.data?
hFile dd ?
lenFile dd ?
hMem dd ?
ReadenBytes dd ?
lpPatternBuffer dd ?

.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc


		invoke ShowCPU, 1
	    print		chr$(13,10)
        push    ebx
        push    edi

		print   addr SzResult1

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest1, addr SzMatch1, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest1, addr SzMatch1, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	
  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest1, addr SzMatch1  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult2

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest2, addr SzMatch2, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest2, addr SzMatch2, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	
  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest2, addr SzMatch2  
       mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult3


  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest3, addr SzMatch3, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest3, addr SzMatch3, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest3, addr SzMatch3  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250




        print   addr SzResult4


  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest4, addr SzMatch4, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest4, addr SzMatch4, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250
	
  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest4, addr SzMatch4  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250



        print   addr SzResult5


  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest5, addr SzMatch5, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest5, addr SzMatch5, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	
  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest5, addr SzMatch5  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250



        print   addr SzResult6

		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest6, addr SzMatch6, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest6, addr SzMatch6, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest6, addr SzMatch6  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult7


  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest7, addr SzMatch7, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest7, addr SzMatch7, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest7, addr SzMatch7  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzResult8


  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest8, addr SzMatch8, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest8, addr SzMatch8, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest8, addr SzMatch8  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250




        print   addr SzResult9

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest9, addr SzMatch9, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest9, addr SzMatch9, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest9, addr SzMatch9  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

      print   addr SzResult10

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest10, addr SzMatch10, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest10, addr SzMatch10, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest10, addr SzMatch10  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

     print   addr SzResult11

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest11, addr SzMatch11, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest11, addr SzMatch11, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest11, addr SzMatch11  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

     print   addr SzResult12

  		print   addr   SzJJb
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, addr SzTest12, addr SzMatch12, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr   SzJJw
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, addr SzTest12, addr SzMatch12, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		 print   addr    SzInLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, addr SzTest12, addr SzMatch12  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

tst13:
te13:
 		call		ReadFileProc
		test		eax, eax
		je			L_Skip

		print   addr SzResult13

  		print   addr   SzJJb
        push    ebp
        counter_begin  1000 , HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1, hMem,  lpPatternBuffer, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr   SzJJw
        push    ebp
        counter_begin  1000 , HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1,  hMem,  lpPatternBuffer, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		 print   addr    SzInLingo
        push    ebp
        counter_begin  1000, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, hMem, lpPatternBuffer  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


	mov		eax, lpPatternBuffer
	mov		ecx, 	lenPattern1
	push		ebx
	mov		ebx, offset lpPattrn1
@@d:
	mov		dl, [ebx]
	add		ebx, 1
	mov		[eax], dl
	add		eax, 1
	dec		ecx
	jne		@@d
	mov		byte ptr [eax],0
	pop	ebx


		print   addr SzResult14

  		print   addr   SzJJb
        push    ebp
        counter_begin  1000 , HIGH_PRIORITY_CLASS
        invoke InstrJJb, 1,  hMem,  lpPatternBuffer, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr   SzJJw
        push    ebp
        counter_begin  1000 , HIGH_PRIORITY_CLASS
        invoke InstrJJw, 1, hMem,  lpPatternBuffer, 0  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		 print   addr    SzInLingo
        push    ebp
        counter_begin  1000, HIGH_PRIORITY_CLASS
        invoke  SrchBytes, hMem, lpPatternBuffer  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250


		invoke  VirtualFree, hMem,0,MEM_RELEASE 
L_Skip:


		mov     eax, input(" Press ENTER to exit...")
        pop     edi
        pop     ebx
        ret

Main	EndP


ReadFileProc:
    invoke	CreateFile, addr szFileName,GENERIC_READ,0,0,\
				OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0 
	cmp		eax, INVALID_HANDLE_VALUE
	je			Exi3
	mov     hFile, eax
	invoke	GetFileSize, hFile, 0
	mov     lenFile, eax
	add		eax, 512			; 512 bytes for second buffer -> lpSrchPattern buffer 
	invoke  VirtualAlloc,0, eax, MEM_COMMIT,PAGE_READWRITE 
    test		eax,eax
    jz			Exi1
	mov     hMem, eax
    invoke  ReadFile, hFile,hMem, lenFile, addr ReadenBytes,0 
    test		eax, eax
	jz			Exi2
	mov		eax, hMem
	add		eax,  ReadenBytes
	add      eax, 15
	and		eax, -16
	mov		lpPatternBuffer,  eax
	mov		ecx, 	lenPattern
	push		ebx
	mov		ebx, offset lpPattrn
@@:
	mov		dl, [ebx]
	add		ebx, 1
	mov		[eax], dl
	add		eax, 1
	dec		ecx
	jne		@b
	mov		byte ptr [eax],0
	pop		ebx
	invoke  CloseHandle, hFile
	or			eax, -1
Exita:
	ret		
Exi2:
	invoke  CloseHandle, hFile
    invoke  VirtualFree, hMem,0,MEM_RELEASE 
	xor		eax, eax	
	jmp		 Exita
Exi1:
    invoke  CloseHandle, hFile
Exi3:
	xor	eax, eax
	jmp		 Exita






; ------------------------------------------------------------------------------
;________________________________________________	;
option		prologue:none						; turn it off
option		epilogue:none							

align 16
InstrJJb proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
;	sMode is reserved for a future implementation of a "ignore case of first character" mode
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
	; and tjj1, 0
	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	movzx ecx, byte ptr [edx]	; 3 cycles to fill xmm0 with first byte
;	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	; test ah, ah
	; je ByteScan
	mov edi, [edx+1]				; next 4 bytes of pattern
	imul ecx, 01010101h			; propagate lobyte
	movd xmm0, ecx
	pshufd xmm0, xmm0, 0		; xmm0 holds first byte of pattern
	mov eax, edi
	or ebx, -1
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	.if al==0
		inc ebx							; clr ebx, pattern byte 2 is zero
		mov edi, ebx					; clear edi
	.elseif ah==0
		movzx ebx, bl					; byte 3 is zero (= and ebx, 0ffh)
		and edi, ebx
	.else
		bswap eax						; one byte shorter, and a bit faster than shr eax, 16
		test ah, ah						; must come first; if not zero, test new al (highest byte before swap)
		.if Zero?
			movzx ebx, bx			; byte 4 is zero (= and ebx, 0ffffh)
		.else
			test al, al					; highest byte before swap
			.if Zero?
				shr ebx, 8				; byte 5 is zero (= ebx, 0ffffffh but faster and shorter) 
			.endif
		.endif
	.endif
	and edi, ebx					; apply mask for pattern bytes 2-5
	test esi, 15						; aligned?
	je L0							; if yes, clear ebp and go directly into the main loop
	lea ebp, [esi+16]				; save unaligned address+16
	movdqu xmm2, [esi]			; load 16 bytes from current unaligned address
	and esi, -16						; align esi downwards
	jmp Lu
	Repeat 0
	nop								; 4=1666, 0=1672
	Endm
L0:	xor ebp, ebp					; clear the alignment flag ----------------------------------------------------------------------
L1:	movdqa xmm2, [esi]
Lu:	movdqa xmm1, xmm0			; xmm0 has first byte of pattern
	lea esi, [esi+16]				; position in mainstring (moving up/down lea or add costs cycles; add esi, 16 is 5 cycles slower on CM, 8 on P4)
	pcmpeqb xmm1, xmm2		; compare memory to pattern byte
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern byte
	pcmpeqb xmm1, xmm2		; look for zero byte (xmm1 is either 0 or ff)
	pmovmskb eax, xmm1		; set byte mask in eax for zero delimiter byte
	test eax, eax					; db 02eh	; branch hint: not taken, no effect
	jne ZBF						; zero byte found? check/clear ebp, then ChkNull
	test edx, edx					; db 03eh	; branch hint: taken, no effect
	je L1							; pattern byte found? no=go back, yes=repeat the exercise with a word

@@:	test ebp, ebp					; 0=aligned from the beginning, or at least second loop
	jne EbpChk					; rare case, once per algo and only if Mainstring is unaligned - so try not to branch

@@:
	REPEAT 3						; 4 same as 3, 1+5 worse: 1=+300, 2=+30
	  bsf ecx, edx					; bit scan for the index ---------------------------------------------------------
	  btr edx, ecx					; clear bit ecx in edx (no add ecx, ebp here: 0.5*171=+85 cycles)
	  mov eax, [esi+ecx-14-1]	; first unaligned chunk contains match; this loop 171 times for TestSubX
	  and eax, ebx					; apply mask
	  cmp eax, edi
	  je FoundPattern
	  test edx, edx
	  je L1							; mysteriously, jmp L0 was consistently ca. 10 cycles faster than jmp L1...
	ENDM
	jmp @B							; 0=no more hits in these 16 bytes, go back searching (this order is here a lot faster)

EbpChk:
	sub ebp, esi					; ebp>0, might be first unaligned loop
	jns @F
	xor ebp, ebp					; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned
	; jmp @B		; needed??	

@@:	bsf ecx, edx						; bit scan with misalignment offset in ebp -----------------------
	btr edx, ecx						; clear bit ecx in edx
	add ecx, ebp					; ebp is the misalignment offset, needed for the whole bitscan loop
	mov eax, [esi+ecx-15]			; first unaligned chunk contains match
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPatternSubEcx		; corrects increased ecx

BadLuck:
	if 0
	xor eax, eax					; default: no match
	cmp ebx, -123					; flag end??
	je NoMatch
	endif

	test edx, edx
	je L0						; unaligned bit scan end, time to clear ebp in L0 -------------
	jmp @B

ZBF:	sub ebp, esi				; ebp>0, might be first unaligned loop
	jns ChkNull
	xor ebp, ebp				; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned

ChkNull:							; this branch only if a nullbyte was found in Mainstring
	bsf ebx, eax				; nullbyte index to ebx
	xor eax, eax				; default: 0=no match
	test edx, edx				; edx holds pattern index
	je NoMatch
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: get outta here
	jb NoMatch
	add ecx, ebp				; jmp FoundPattern is slower
;	m2m ebx, -123				; flag end
	;				0						 16			 32			48 51
	;SmSrcU	db "123456789012a4X67890?2345b78901234X67890c234567890X6789012345", 0 ;, "X67890"
	;SmPat7	db "X678901", 0
FoundPatternSubEcx:
	sub ecx, ebp
FoundPattern:						; we need to check the rest of the string here
	cmp edi, 0ffffffh			; 3 bytes = 5-byte pattern, OK
	jbe Match
	push esi
	push ebx
	lea ebx, [esi+ecx-16+4]			; Mainstring: 1 byte covered by inner loop, 4 by edi, so we check from byte 6 onwards
	mov esi, [esp+6*4+3*4+4+4]		; Pattern
	add ebx, ebp
	add esi, 5
@@:
	if UseLodsb
		lodsb			; sometimes a few cycles faster (but difficult to prove)
		test al, al		; this cannot be shifted below because of the rare case of equality after the zero delimiter:
		je @F			; db "Mainstr", 0, "abc" ... db "str", 0, "abx"  would crash
	else
		movzx eax, byte ptr [esi]		; esi=Substr (mov al is a few cycles slower)
		test eax, eax
		je @F
		inc esi
	endif
	inc ebx
	cmp al, [ebx]						; ebx=Mainstr
	je @B

@@:	pop ebx
	pop esi
	jne BadLuck						; test al, al not needed, flags still valid

Match:
	sub esi, [esp+6*4+2*4]			; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]				; and adjust for the index
	add eax, ebp						; ebp = offset in first unaligned chunk

NoMatch:
	pop edx								; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	;and tjj1, 0
	ret 4*4							; 4 arguments

;ByteScan:
;	imul eax, 01010101h			; propagate lobyte
;	movd xmm3, eax
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
;@@:	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
;	movdqa xmm2, xmm1			; save 16 bytes for testing the zero delimiter
;	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
;	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
;	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
;	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
;	pmovmskb ecx, xmm2			; set byte mask (bits 0...15) in ecx for zero delimiter
;	test ecx, ecx					; zero byte found?
;	jnz @F							; check ebp, then ChkNull
;	test edx, edx					; pattern found?
;	jz @B							; 0=no pattern byte found, go back

;@@:	xor eax, eax					; default; no match
;	bsf edx, edx					; 34", 0, "X6
;	test ecx, ecx					; nullbyte found?
;	je @F
;	bsf ecx, ecx						; if yes, we need to check if
;	cmp ecx, edx					; it comes before or after the match
;	jb NoMatch

;@@:	lea eax, [esi+edx-15]
;	sub eax, [esp+6*4+2*4]
;	jmp NoMatch
InstrJJb endp
InstrJJbe:

align 16
InstrJJw proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
;	sMode is reserved for a future implementation of a "ignore case of first character" mode
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
	; and tjj1, 0
	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	test ah, ah
	je ByteScan
	imul eax, 00010001h			; propagate loword
	mov edi, [edx+2]				; next 4 bytes of pattern
	movd xmm3, eax
	or ebx, -1
	mov eax, edi
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	.if al==0
		xor ebx, ebx					; pattern byte 3 is zero
		mov edi, ebx					; clear edi
	.elseif ah==0
		movzx ebx, bl					; byte 4 is zero (= and ebx, 0ffh)
		and edi, ebx
	.else
		bswap eax						; one byte shorter, and a bit faster than shr eax, 16
		test ah, ah						; must come first; if not zero, test new al (highest byte before swap)
		.if Zero?
			movzx ebx, bx			; byte 5 is zero (= and ebx, 0ffffh)
		.else
			test al, al					; highest byte before swap
			.if Zero?
				shr ebx, 8				; byte 6 is zero (= ebx, 0ffffffh but faster and shorter) 
			.endif
		.endif
	.endif
	and edi, ebx					; apply mask for pattern bytes 2-5
	test esi, 15						; aligned?
	je L0							; if yes, clear ebp and go directly into the main loop
	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
	movdqu xmm4, [esi+1]		; load another16 bytes
	lea ebp, [esi+16]				; save unaligned address+16
	and esi, -16						; align esi downwards
	movdqa xmm2, xmm1			; load 16 bytes for testing the zero delimiter
	jmp Lu
;	repeat 0
;	nop								; 0=2530, 1=2540, 2=... alignment doesn't matter on a modern CPU
;	endm
L0:	xor ebp, ebp					; clear the alignment flag ----------------------------------------------------------------------
L1:	movdqa xmm1, [esi]			; load 16 bytes from current aligned address; pshufd xmm1, [esi], 0E4h ([url=http://www.mark.masmcode.com/]Mark[/url]) is 200 cycles slower
	movdqu xmm4, [esi+1]		; load another 16 bytes - must be in the middle
	movdqa xmm2, [esi]			; load 16 bytes for testing the zero delimiter - faster than movdqa xmm2, xmm1, even on Celeron M!
Lu:	pcmpeqw xmm1, xmm3		; compare packed words in xmm1 and xmm3 for equality
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pcmpeqw xmm4, xmm3		; compare packed words in xmm4 and xmm3 for equality
	lea esi, [esi+16]				; position in mainstring (moving up/down lea or add costs cycles; add esi, 16 is 5 cycles slower on CM, 8 on P4)
	pmovmskb ecx, xmm4			; set byte mask in ecx for search pattern word
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb eax, xmm2		; set byte mask in eax for zero delimiter byte
	shl ecx, 1						; adjust for esi+1 (add ecx, ecx is a lot slower)
	test eax, eax
	jne ZBF						; zero byte found? check/clear ebp, then ChkNull
	or edx, ecx						; one of them needs to have the word
	je L1							; 0=no pattern byte found, go back ------------------------------------------------------

@@:	test ebp, ebp					; 0=aligned from the beginning, or at least second loop
	jne EbpChk					; rare case, once per algo and only if Mainstring is unaligned - so try not to branch

@@:	bsf ecx, edx						; bit scan for the index ---------------------------------------------------------
	btr edx, ecx						; clear bit ecx in edx (no add ecx, ebp here: 0.5*171=+85 cycles)
	mov eax, [esi+ecx-14]			; first unaligned chunk contains match; this loop 171 times for TestSubX
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPattern
	test edx, edx
	jnz @B							; 0=no more hits in these 16 bytes, go back searching (reversing order is a lot slower)
	; mysteriously, jmp L0 is consistently ca. 10 cycles faster than jmp L1...
	jmp L0							; bit scan end -----------------------------------------------------------------------

EbpChk:
	sub ebp, esi					; ebp>0, might be first unaligned loop
	jns @F
	xor ebp, ebp					; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned
	jmp @B	

@@:	bsf ecx, edx						; bit scan with misalignment offset in ebp -----------------------
	btr edx, ecx						; clear bit ecx in edx
	add ecx, ebp					; ebp is the misalignment offset, needed for the whole bitscan loop
	mov eax, [esi+ecx-14]			; first unaligned chunk contains match
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPattern

BadLuck:
	test edx, edx
	jnz @B
	jmp L0							; unaligned bit scan end, time to clear ebp in L0 -------------

ZBF:	sub ebp, esi				; ebp>0, might be first unaligned loop
	jns ChkNull
	xor ebp, ebp				; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned

ChkNull:							; this branch only if a nullbyte was found in Mainstring
	mov ebx, eax				; position of zero byte
	xor eax, eax				; default: 0=no match
	or edx, ecx					; one of them needs to have the word
	je NoMatch
	bsf ebx, ebx				; nullbyte index in ebx
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: get outta here
	jb NoMatch
	add ecx, ebp				; lea ecx, [ecx+ebp] 2 bytes longer and a bit slower

FoundPattern:						; we need to check the rest of the string here
	sub ecx, ebp
	cmp edi, 0ffffffh			; 3 bytes = 5-byte pattern, OK
	jbe Match
	push esi
	push ebx
	lea ebx, [esi+ecx-16+2+3]			; Mainstring: 2 bytes covered by inner loop, 4 by edi, so we check from byte 7 onwards
	mov esi, [esp+6*4+3*4+4+4]		; Pattern
	add ebx, ebp
	add esi, 6
@@:
	if UseLodsb
		lodsb			; a few cycles faster (but difficult to prove)
		test al, al		; this cannot be shifted below because of the rare case of equality after the zero delimiter:
		je @F			; db "Mainstr", 0, "abc" ... db "str", 0, "abx"  would crash
	else
		movzx eax, byte ptr [esi]		; esi=Substr (mov al is a few cycles slower)
		test eax, eax
		je @F
		inc esi
	endif
	inc ebx
	cmp al, [ebx]						; ebx=Mainstr
	je @B

@@:	pop ebx
	pop esi
	jne BadLuck						; test al, al not needed, flags still valid

Match:
	sub esi, [esp+6*4+2*4]			; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]				; and adjust for the index
	add eax, ebp						; ebp = offset in first unaligned chunk

NoMatch:
	pop edx								; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	ret 4*4							; 4 arguments

ByteScan:
	imul eax, 01010101h			; propagate lobyte
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
@@:	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
	movdqa xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb ecx, xmm2			; set byte mask (bits 0...15) in ecx for zero delimiter
	test ecx, ecx					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	test edx, edx					; pattern found?
	jz @B							; 0=no pattern byte found, go back

@@:	xor eax, eax					; default; no match
	bsf edx, edx					; 34", 0, "X6
	test ecx, ecx					; nullbyte found?
	je @F
	bsf ecx, ecx						; if yes, we need to check if
	cmp ecx, edx					; it comes before or after the match
	jb NoMatch

@@:	lea eax, [esi+edx-15]
	sub eax, [esp+6*4+2*4]
	jmp NoMatch
InstrJJw endp
InstrJJwe:



comment	* SrchBytes by Lingo *			
align		16		
SrchBytes	proc		lpBuffer:dword, lpSrchPatt:dword
  mov		edx, [esp+2*4]
  mov		eax, [esp+1*4]  
  movdqu	xmm2, xmmword ptr[edx]
  pxor		xmm3, xmm3
@Loop:
    pcmpistri	xmm2, xmmword ptr [eax], 0Ch
    jna			@f		 
	pcmpistri	xmm2, xmmword ptr [eax+16], 0Ch
    lea			eax, [eax+32]
    ja			@Loop
	lea			ecx, [ecx-16]
@@:
	lea			eax, [eax+ecx]
    jnc			L_not_found
	sub			edx, eax
	movd		xmm7, eax
@@:
    movdqu		xmm1,	xmmword ptr[eax + edx]
    pcmpistrm	xmm3,	xmm1, 58h
    movdqu		xmm4,	xmmword ptr[eax]
	add			eax,	16
    pand		xmm4,	xmm0
    pcmpistri	xmm1,	xmm4, 18h
    ja			@b
	movd		eax,	xmm7
	jnc			L_found
	add			edx, eax
	add			eax, 1
	jne			@Loop
align 8
L_not_found:
	xor		eax, eax
	ret		2*4
align 8
L_found:
	sub		eax, [esp+1*4] 
	ret		2*4
SrchBytes	endp									;
;..................................................	;
option			prologue:prologuedef				; turn back on the defaults
option			epilogue:epiloguedef				;

End	Start

